/**********************************************************************/
/*                                                                    */
/*   Licensed Materials - Property of IBM.                            */
/*   IBM XL C/C++ Advanced Edition V8.0 for Linux                     */
/*   5724-M16                                                         */
/*   (C) Copyright IBM Corp. 2003, 2005.                              */
/*   All Rights Reserved.                                             */
/*   US Government Users Restricted Rights -                          */
/*   Use, duplication or disclosure restricted by                     */
/*   GSA ADP Schedule Contract with IBM Corp.                         */
/*                                                                    */
/**********************************************************************/

#if defined __MATH__ /* && !defined __NO_MATH_INLINES */

# ifdef __cplusplus

# include <features.h>
# include <sys/types.h>

extern "C" {
  extern int abs(int) __THROW __attribute__((__IBMBuiltin__));
  extern long labs(long) __THROW __attribute__((__IBMBuiltin__));
  
# ifdef _LONG_LONG
  extern long long llabs(long long) __THROW __attribute__((__IBMBuiltin__));
# endif

# ifdef _ALL_SOURCE
  extern void imul_dbl(long, long, long *) __THROW __attribute__((__IBMBuiltin__));
  extern void umul_dbl(unsigned long, unsigned long, unsigned long *) __THROW __attribute__((__IBMBuiltin__));
# endif
};

# endif /* __cplusplus */

#endif /* defined __MATH && !defined __NO_MATH_INLINES */

#undef div
#undef ldiv

#include_next <stdlib.h>

#if defined __MATH__ /* && !defined __NO_MATH_INLINES */

# ifndef __cplusplus /* ! __cplusplus */

#   define abs(__j)             __abs(__j)
#   define llabs(__j)           __llabs(__j)
#   define labs(__j)            __labs(__j)
#   define div(__numer,__denom)   __div(__numer,__denom)
#   define ldiv(__numer,__denom)  __ldiv(__numer,__denom)

#   if defined _ALL_SOURCE
#     define imul_dbl(__a, __b, __c)  __imul_dbl(__a, __b, __c)
#     define umul_dbl(__a, __b, __c)  __umul_dbl(__a, __b, __c)
#   endif /* _ALL_SOURCE */

# endif /* __cplusplus */

#endif /* defined __MATH && !defined __NO_MATH_INLINES */
